SystemOrganization addCategory: #Mock!

MwMethodWrapperInstVars variableSubclass: #MethodStubInstVars
	instanceVariableNames: 'returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mock'!

!MethodStubInstVars methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:08'!
returnValue

	^ returnValue.! !

!MethodStubInstVars methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:09'!
returnValue: anObject

	returnValue := anObject.! !

MwMethodWrapper variableByteSubclass: #MethodStubWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mock'!

MethodStubWrapper variableByteSubclass: #MethodStub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mock'!

!MethodStub classSide methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:09'!
removeAll
	"self removeAll"

	self allInstances do: [ :e | e remove ].! !

!MethodStub classSide methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/2/2012 02:26'!
replacing: method 

	| stub realMethod |
	(method isKindOf: MethodStub)
		ifTrue: [
			realMethod := method clientMethod.
			method uninstall ]
		ifFalse: [ realMethod := method ].
	
	stub := self on: realMethod selector inClass: realMethod methodClass.
	^ stub
		install;
		yourself.! !

!MethodStub methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:07'!
printOn: aStream

	aStream nextPutAll: 'Stub for ', self definingClass name, '>>', self clientSelector.! !

!MethodStub methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:09'!
remove

	self uninstall.! !

!MethodStub methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:08'!
return: anObject

	self properties returnValue: anObject.! !

!MethodStub methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:08'!
returnValue

	^ self properties returnValue.! !

!MethodStubWrapper classSide methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 19:53'!
canWrap: aSelector inClass: aClass
	"Test if a method can be wrapped without causing infinite recursion."

	| class method |
	(aClass includesBehavior: MwMethodWrapper) ifTrue: [^ false].
	((aClass includesBehavior: CompiledMethod)
		and: [aSelector == #valueWithReceiver:arguments:])
			ifTrue: [^ false].
	((aClass includesBehavior: BlockClosure)
		and: [#(ensure: value) includes: aSelector])
			ifTrue: [^ false].
	class := aClass whichClassIncludesSelector: aSelector.
	class isNil ifTrue: [^ true].
	method := class compiledMethodAt: aSelector ifAbsent: [nil].
	^ method isNil or: [(self primitives includes: method primitive) not]! !

!MethodStubWrapper classSide methodsFor: 'as yet unclassified' stamp: 'SPD 5/1/2012 18:58'!
methodPropertiesClass

	^ MethodStubInstVars.! !

!MethodStubWrapper methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/2/2012 02:23'!
install

	| holdingClass method |
	self flag: #rhi. "KLUDGE: Einwegwrapper."
	self wasActive ifTrue: [self error: 'Einwegwrapper!!'].
	holdingClass := self wrappedClass whichClassIncludesSelector: self clientSelector.
	holdingClass isNil ifTrue: [^ self wrappedClass].
	method := holdingClass compiledMethodAt: self clientSelector.
	method == self ifTrue: [^ self].
	self
		clientMethod: method;
		setSourcePointer: method sourcePointer.
	method isMwMethodWrapper
		ifTrue: [
			method wrappingWrapper: self.
			self definingClass: method definingClass]
		ifFalse: [self definingClass: holdingClass].
	SystemChangeNotifier uniqueInstance doSilently: [ self wrappedClass addSelector: self clientSelector withMethod: self ].! !

!MethodStubWrapper methodsFor: 'as yet unclassified' stamp: 'SPD 5/1/2012 19:00'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	"This is the general case where you want both a before and after method, but if you
	want just a before method, you might want to override this method for optimization."

	^ self returnValue.! !

TestCase subclass: #Specification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mock'!

Specification subclass: #MockSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mock'!

!MockSpecification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 22:16'!
testDateAndTime
	
	| pastTime stub |
	pastTime := DateAndTime now - 1 hour.
	stub := DateAndTime stub: #now andReturn: pastTime.
	
	self assert: pastTime equals: DateAndTime now.
	(Delay forMilliseconds: 10) wait.
	self assert: pastTime equals: DateAndTime now.! !

!MockSpecification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:14'!
testIt

	| stubbedReturn stub |
	stubbedReturn := 'new value'.
	self assert: ClassToStub existingClassSideMethod ~= stubbedReturn.
	
	stub := ClassToStub stub: #existingClassSideMethod andReturn: stubbedReturn.
	
	self assert: stubbedReturn equals: ClassToStub existingClassSideMethod.! !

!MockSpecification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 21:06'!
testPrinting

	| stub |
	stub := ClassToStub stub: #existingClassSideMethod andReturn: 'new value'.
	
	self assert: stub printString equals: 'Stub for ClassToStub class>>existingClassSideMethod'.! !

!MockSpecification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/2/2012 02:26'!
testStubBasic

	| stub |
	stub := ClassToStub stub: #existingClassSideMethod andReturn: 3.
	self assert: (stub isKindOf: MethodStub).! !

!MockSpecification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/1/2012 23:55'!
testStubTwice

	| firstStubbedReturn secondStubbedReturn |
	firstStubbedReturn := 'newer value'.
	secondStubbedReturn := 'newest value'.
	self assert: ClassToStub existingClassSideMethod ~= firstStubbedReturn.
	self assert: ClassToStub existingClassSideMethod ~= secondStubbedReturn.
	
	ClassToStub stub: #existingClassSideMethod andReturn: firstStubbedReturn.
	ClassToStub stub: #existingClassSideMethod andReturn: secondStubbedReturn.
	self assert: secondStubbedReturn equals: ClassToStub existingClassSideMethod.! !

!MockSpecification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/2/2012 02:26'!
testStubbedMethod

	| method stub |
	method := ClassToStub class>>#existingClassSideMethod.
	stub := MethodStub replacing: method.
	self assert: (stub isKindOf: MethodStub).! !

!Specification classSide methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 5/2/2012 02:26'!
cleanSystem
	"self cleanSystem"

	MethodStub allInstances do: [ :e | e remove ].
	"Smalltalk garbageCollect.
	MethodStub allInstances size = 0 ifFalse: [ self error: 'Unable to remove test doubles' ]."! !

!Specification classSide methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/24/2012 21:53'!
isAbstract

	^ self name = #Specification.! !

!Specification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/24/2012 21:25'!
removeTestDoubles

	self class cleanSystem.! !

!Specification methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/24/2012 21:25'!
runCase
	self resources do: [:each | each availableFor: self].
	[self setUp.
	self performTest] ensure: [
		self tearDown.
		self removeTestDoubles.
		self cleanUpInstanceVariables]! !

Object subclass: #ClassToStub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mock'!

!ClassToStub classSide methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/22/2012 12:41'!
existingClassSideMethod

	^ 'original value'.! !

!Object class methodsFor: '*mock' stamp: 'SeanDeNigris 5/2/2012 02:26'!
stub: aSymbol andReturn: anObject

	| stub |
	stub := self class methodDict
		at: aSymbol
		ifPresent: [ :m | MethodStub replacing: m ]
		ifAbsent: [ MethodStub new ].
	^ stub
		return: anObject;
		yourself.! !
